############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

import unittest,ConfigParser
from pyGlobus.xio import XioAttr
from pyGlobus.xio import XioStack
from pyGlobus.xio import XioDriver
from pyGlobus.xio import XioFile
from pyGlobus.xio import XioServer
from pyGlobus import xioc

config = None

class XioAttrTestCase(unittest.TestCase):
    def tearDown(self):
        pass
    def checkCreateAndDel(self):
        attr = XioAttr()
        del attr

class XioStackTestCase(unittest.TestCase):
    def tearDown(self):
        pass
    def checkCreateAndDel(self):
        attr = XioAttr()
        stack = XioStack(attr)
        del stack
        del attr
        


class XioDriverTestCase(unittest.TestCase):
    def tearDown(self):
        pass
    def checkLoadUnload(self):
        driver = XioDriver()
        driver.load("tcp")
        driver.unload() 
        del driver
        

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(XioAttrTestCase, "check"))
    suite.addTest(unittest.makeSuite(XioStackTestCase, "check"))
    suite.addTest(unittest.makeSuite(XioDriverTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
   
