#!/usr/bin/env python
############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import sys, time, urlparse, optparse
from ConfigParser import ConfigParser

CONFIG_FILE = 'config.txt'
SEC_PATHS = 'Paths'
TEST = None

op = optparse.OptionParser()
op.add_option("-f", "--factory",
              action="store_true", dest="factory", default=False,
              help="use managed job factory")
(options, args) = op.parse_args()
if options.factory is True:
    from pyGridWare.generated.stubs.ManagedJobFactory_services import *
    TEST = 'ManagedJobFactoryService'
else:
    from pyGridWare.generated.stubs.ManagedJob_services import *
    TEST = 'ManagedJobService'


def RunMangedJobFactoryService(portAddress, **kw):
    '''Use Managed Job Factory Service
    '''
    loc = ManagedJobFactoryServiceLocator()
    port = loc.getManagedJobFactoryPortType(portAddress=portAddress, **kw)

    class QName(tuple):
         typecode = GetResourcePropertyRequest()
    port.GetResourceProperty(\
        QName(("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd","Entry")))

    #request = createManagedJobInputMessage()
    #request._InitialTerminationTime = time.gmtime(time.time()+20)
    #request._JobID = None
    #request._Subscribe = None
    #request._job = None
    #request._multiJob = None
    #port.createManagedJob(request)


def RunMangedJobService(portAddress, **kw):
    '''Use Managed Job Service
    '''
    loc = ManagedJobServiceLocator()
    port = loc.getManagedJobPortType(portAddress=portAddress, **kw)

    request = RegisterInputMessage()
    request._data = "DATA"
    request._rank = 5
    port.register(request)


def main():
    cp = ConfigParser()
    cp.read(CONFIG_FILE)
    path = cp.get(SEC_PATHS, TEST)
    host = cp.get('Location', 'host')
    port = cp.getint('Location', 'port')
    netloc = '%s:%d'%(host,port)
    urlTuple = ('http',netloc,path,'','','')
    url = urlparse.urlunparse(urlTuple)
    scheme,netloc,path,params,query,fragment = urlparse.urlparse(url)
    kw = {'tracefile':sys.stdout, 'url':path}
    portAddress = url
    if options.factory is True: 
        RunMangedJobFactoryService(portAddress, **kw)
    else: 
        RunMangedJobService(portAddress, **kw)


if __name__ == '__main__':
    main()

