#!/usr/bin/env python
############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import sys, time, urlparse
from ConfigParser import ConfigParser
from pyGridWare.generated.stubs.WidgetService_services import *

CONFIG_FILE = 'config.txt'
SEC_PATHS = 'Paths'
TEST = 'WidgetService'


def Scenario_1(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    port.create(request)

def Scenario_2(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    response = port.create(request)

    kw['endPointReference'] = response._EndpointReference
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = destroyRequest()
    response = port.destroy(request)


def Scenario_3(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    response = port.create(request)

    kw['endPointReference'] = response._EndpointReference
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = setTermTimeRequest()
    request._RequestedTerminationTime = time.gmtime(time.time()+5.0)
    response = port.setTermTime(request)

def Scenario_4(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    response = port.create(request)

    kw['endPointReference'] = response._EndpointReference
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = setTermTimeRequest()
    request._RequestedTerminationTime = time.gmtime(time.time()+30.0)
    response = port.setTermTime(request)

    class QualifiedName(tuple):
        """Use to package data for QName typecode, this
        way the data is not recognized as a sequence type.
        """
    request = QualifiedName(\
        ("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd",\
         "TerminationTime"))
    response = port.getResourceProperty(request)


def main():
    cp = ConfigParser()
    cp.read(CONFIG_FILE)

    path = cp.get(SEC_PATHS, TEST)
    host = cp.get('Location', 'host')
    port = cp.getint('Location', 'port')
    netloc = '%s:%d'%(host,port)
    urlTuple = ('http',netloc,path,'','','')
    url = urlparse.urlunparse(urlTuple)
    scheme,netloc,path,params,query,fragment = urlparse.urlparse(url)
    kw = {'tracefile':sys.stdout, 'url':path}
    Scenario_4(url, **kw)


if __name__ == '__main__':
    main()

