############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import ZSI.TC
from twisted.python import log
from pyGridWare.generated.types.Counter_services_types import counter_com
from pyGridWare.properties.ResourceProperties import ResourceProperties


class CounterKey(int):
    typecode = ZSI.TC.Iint(pname=("http://counter.com",'CounterKey'))


class CounterProperties(ResourceProperties):
    '''Associate a TopicSpace with every targetNamespace, generate a notification messsage
    when observe a resource property change.  Associate the notification message with a
    topic, and push to NotificationProducer.  NP will look for the topic in its Topic Set,
    if find a Subscription matching send a "Notify" message.

    ??
    <wstop:topicSpace name="ResourcePropertiesTopicSpace" targetNamespace="http://counter.com">
        <wstop:topic name="CounterResourceProperty">
            <wstop:topic name="Value" messageTypes="SomeNotificationMessage"/>
        </wstop:topic>
    </wstop:topicSpace>

    or

    <wstop:topicSpace name="ResourcePropertiesTopicSpace" targetNamespace="http://counter.com">
        <wstop:topic name="Value" messageTypes="SomeNotificationMessage"/>
        <wstop:topic name="terminationTime" messageTypes="SomeNotificationMessage"/>
        <wstop:topic name= bla bla.../>
    </wstop:topicSpace>
    '''
    declaration = counter_com.CounterRP_Dec

    def getValue(self):
        '''convience method for accessing Value
        '''
        return self.getResourceProperty('http://counter.com', 'Value')

    def setValue(self, value):
        '''convience method for setting Value
        '''
        self.setResourceProperty('http://counter.com', 'Value', value)


