############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import ZSI.TC
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.properties.ResourceProperties import ResourceProperties
from pyGridWare.generated.types.WidgetService_services_types import *


class WidgetKey(int):
    typecode = ZSI.TC.Iint(pname=("http://widgets.com/",'ResourceID'))


class WidgetProperties(ResourceProperties):
    declaration = docs_oasis_open_org_wsrf_2004_06_wsrf_WS_ResourceLifetime_1_2_draft_01_xsd.ScheduledResourceTerminationRP_Dec

    def __init__(self):
        ResourceProperties.__init__(self)

    def getTopicExpression(self):
        return self._element._TopicExpression
    def setTopicExpression(self, value): 
        #assert isinstance(value, , 'expecting boolean for UseNotify value.'
        self._element._TopicExpression = value
    TopicExpression = property(getTopicExpression, setTopicExpression, None, 'TopicExpression element')

    def getUseNotify(self):
        return self._element._UseNotify
    def setUseNotify(self, value):
        assert type(value) is bool, 'expecting boolean for UseNotify value.'
        self._element._UseNotify = value
    UseNotify = property(getUseNotify, setUseNotify, None, 'UseNotify element')

