############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.generated.properties.SubscriptionProducer_properties import \
    SubscriptionProperties, SubscriptionKey


class SubscriptionManagerHome(PersistentResourceHome):

    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, SubscriptionKey.typecode)
        return self.get(key)


class SubscriptionContext(ResourceContext):
    home = SubscriptionManagerHome()

    def __init__(self):
        ResourceContext.__init__(self)
        self.properties = SubscriptionProperties()

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, SubscriptionKey(resourceID))

