from pyGridWare.generated.stubs.ManagedJobFactory_services import *
from pyGridWare.wsrf.resource import WSResource

class ManagedJobFactory(WSResource):
    soapAction = {
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty': 'wsa_GetResourceProperty',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties': 'wsa_QueryResourceProperties',
        'http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobFactoryPortType/createManagedJobRequest': 'wsa_createManagedJob',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties': 'wsa_GetMultipleResourceProperties',
        }
    wsAction = {
        'wsa_GetResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse',
        'wsa_QueryResourceProperties': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourcePropertiesResponse',
        'wsa_createManagedJob': 'http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobFactoryPortType/createManagedJobResponse',
        'wsa_GetMultipleResourceProperties': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourcePropertiesResponse',
        }

    def __init__(self, post='/wsrf/services/', **kw):
        WSResource.__init__(self, post)

    def wsa_GetMultipleResourceProperties(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetMultipleResourcePropertiesRequest())

        # assign return values to response object
        response = GetMultipleResourcePropertiesResponse()

        return response

    def wsa_GetResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetResourcePropertyRequest())

        # assign return values to response object
        response = GetResourcePropertyResponse()

        return response

    def wsa_QueryResourceProperties(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(QueryResourcePropertiesRequest())

        # assign return values to response object
        response = QueryResourcePropertiesResponse()

        return response

    def wsa_createManagedJob(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(createManagedJobInputMessage())

        # assign return values to response object
        response = createManagedJobOuputMessage()

        return response
