from pyGridWare.generated.stubs.ManagedJob_services import *
from pyGridWare.wsrf.resource import WSResource

class ManagedJob(WSResource):
    soapAction = {
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty': 'wsa_GetResourceProperty',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage': 'wsa_GetCurrentMessage',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties': 'wsa_QueryResourceProperties',
        'http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/registerRequest': 'wsa_register',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe': 'wsa_Subscribe',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime': 'wsa_SetTerminationTime',
        'http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/releaseRequest': 'wsa_release',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy': 'wsa_Destroy',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties': 'wsa_GetMultipleResourceProperties',
        }
    wsAction = {
        'wsa_GetResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse',
        'wsa_GetCurrentMessage': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse',
        'wsa_QueryResourceProperties': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourcePropertiesResponse',
        'wsa_register': 'http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/registerResponse',
        'wsa_Subscribe': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse',
        'wsa_SetTerminationTime': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse',
        'wsa_release': 'http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/releaseResponse',
        'wsa_Destroy': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse',
        'wsa_GetMultipleResourceProperties': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourcePropertiesResponse',
        }

    def __init__(self, post='/wsrf/services/', **kw):
        WSResource.__init__(self, post)

    def wsa_Destroy(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(DestroyRequest())

        # assign return values to response object
        response = DestroyResponse()

        return response

    def wsa_GetCurrentMessage(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetCurrentMessageRequest())

        # assign return values to response object
        response = GetCurrentMessageResponse()

        return response

    def wsa_GetMultipleResourceProperties(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetMultipleResourcePropertiesRequest())

        # assign return values to response object
        response = GetMultipleResourcePropertiesResponse()

        return response

    def wsa_GetResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetResourcePropertyRequest())

        # assign return values to response object
        response = GetResourcePropertyResponse()

        return response

    def wsa_QueryResourceProperties(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(QueryResourcePropertiesRequest())

        # assign return values to response object
        response = QueryResourcePropertiesResponse()

        return response

    def wsa_SetTerminationTime(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SetTerminationTimeRequest())

        # assign return values to response object
        response = SetTerminationTimeResponse()

        return response

    def wsa_Subscribe(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SubscribeRequest())

        # assign return values to response object
        response = SubscribeResponse()

        return response

    def wsa_register(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(RegisterInputMessage())

        # assign return values to response object
        response = RegisterOutputMessage()

        return response

    def wsa_release(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(releaseInputMessage())

        # assign return values to response object
        response = releaseOutputMessage()

        return response
