from pyGridWare.generated.stubs.WS_BaseNotification_services import *
from pyGridWare.wsrf.resource import WSResource

class WS_BaseNotification(WSResource):
    soapAction = {
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty': 'wsa_GetResourceProperty',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage': 'wsa_GetCurrentMessage',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscription': 'wsa_PauseSubscription',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe': 'wsa_Subscribe',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Notify': 'wsa_Notify',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime': 'wsa_SetTerminationTime',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy': 'wsa_Destroy',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscription': 'wsa_ResumeSubscription',
        }
    wsAction = {
        'wsa_GetResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse',
        'wsa_GetCurrentMessage': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse',
        'wsa_PauseSubscription': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscriptionResponse',
        'wsa_Subscribe': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse',
        'wsa_Notify': 'None',
        'wsa_SetTerminationTime': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse',
        'wsa_Destroy': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse',
        'wsa_ResumeSubscription': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscriptionResponse',
        }

    def __init__(self, post='/wsrf/services/', **kw):
        WSResource.__init__(self, post)

    def wsa_GetCurrentMessage(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetCurrentMessageRequest())

        # assign return values to response object
        response = GetCurrentMessageResponse()

        return response

    def wsa_GetResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetResourcePropertyRequest())

        # assign return values to response object
        response = GetResourcePropertyResponse()

        return response

    def wsa_Subscribe(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SubscribeRequest())

        # assign return values to response object
        response = SubscribeResponse()

        return response

    def wsa_Notify(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(Notify())

        # NO output

        return None

    def wsa_Destroy(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(DestroyRequest())

        # assign return values to response object
        response = DestroyResponse()

        return response

    def wsa_GetResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetResourcePropertyRequest())

        # assign return values to response object
        response = GetResourcePropertyResponse()

        return response

    def wsa_PauseSubscription(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(PauseSubscriptionRequest())

        # assign return values to response object
        response = PauseSubscriptionResponse()

        return response

    def wsa_ResumeSubscription(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(ResumeSubscriptionRequest())

        # assign return values to response object
        response = ResumeSubscriptionResponse()

        return response

    def wsa_SetTerminationTime(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SetTerminationTimeRequest())

        # assign return values to response object
        response = SetTerminationTimeResponse()

        return response
