from pyGridWare.generated.stubs.WidgetService_services import *
from pyGridWare.wsrf.resource import WSResource

class WidgetService(WSResource):
    soapAction = {
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl/GetResourceProperty': 'wsa_getResourceProperty',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/SetResourceProperties': 'wsa_setResourceProperty',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl/QueryResourceProperties': 'wsa_queryResourceProperties',
        'http://widgets.com/createWidget': 'wsa_create',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.wsdl/Subscribe': 'wsa_Subscribe',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/Destroy': 'wsa_destroy',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/SetTerminationTime': 'wsa_setTermTime',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/GetMultipleResourceProperties': 'wsa_getMultipleResourceProperties',
        }
    wsAction = {
        'wsa_getResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl/GetResourcePropertyResponse',
        'wsa_setResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/SetResourcePropertiesResponse',
        'wsa_queryResourceProperties': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl/QueryResourcePropertiesResponse',
        'wsa_create': 'http://widgets.com/createWidgetResponse',
        'wsa_Subscribe': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.wsdl/SubscribeResponse',
        'wsa_destroy': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/DestroyResponse',
        'wsa_setTermTime': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl/SetTerminationTimeResponse',
        'wsa_getMultipleResourceProperties': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl/GetMultipleResourcePropertiesResponse',
        }

    def __init__(self, post='/services/widgetService', **kw):
        WSResource.__init__(self, post)

    def wsa_Subscribe(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SubscribeRequest())

        # assign return values to response object
        response = SubscribeResponse()

        return response

    def wsa_create(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(createRequest())

        # assign return values to response object
        response = createResponse()

        return response

    def wsa_destroy(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(destroyRequest())

        # assign return values to response object
        response = destroyResponse()

        return response

    def wsa_getMultipleResourceProperties(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(multipleResPropRequest())

        # assign return values to response object
        response = multipleResPropResponse()

        return response

    def wsa_getResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(resPropRequest())

        # assign return values to response object
        response = resPropResponse()

        return response

    def wsa_queryResourceProperties(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(QRPRequest())

        # assign return values to response object
        response = QRPResponse()

        return response

    def wsa_setResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SRPRequest())

        # assign return values to response object
        response = SRPResponse()

        return response

    def wsa_setTermTime(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(setTermTimeRequest())

        # assign return values to response object
        response = setTermTimeResponse()

        return response
