############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
__all__ = [\
    'Addressing_types',
    'Authenticator_services_types',
    'BaseFaults_types',
    'BaseNotification_types',
    'Counter_services_types',
    'NotificationConsumer_services_types',
    'ResourceLifetime_types',
    'ResourceProperties_types',
    'SecureConversation_services_types',
    'SubscriptionManagerService_services_types',
]
import ZSI as _ZSI
from ZSI.wsdl2python import ElementDeclaration as _ElementDeclaration
from ZSI.wsdl2python import TypeDefinition as _TypeDefinition
#Addressing_types
#Authenticator_services_types
#BaseFaults_types
#BaseNotification_types
#Counter_services_types
#NotificationConsumer_services_types
#ResourceLifetime_types
#ResourceProperties_types
import SecureConversation_services_types as _SecureConversation_services_types
#SubscriptionManagerService_services_types


def GetNSContainer(module, targetNamespace):
    ns_class = None
    for ns_class in module.__dict__.values():
        tns = getattr(ns_class, 'targetNamespace', None) 
        if tns is None: continue
        if tns == targetNamespace: break
    else:
        raise RuntimeError, 'can not find targetNamespace(%s) in module(%s)' %(targetNamespace, module)
    return ns_class


# Patches for Unions
class _ns_trust:
    targetNamespace = 'http://schemas.xmlsoap.org/ws/2004/04/trust'

    # JRB NOT GENERATED BECAUSE OF UNION
    class RequestTypeOpenEnum_Def(_ZSI.TC.URI):
        # <xs:simpleType name='RequestTypeOpenEnum' >
        #  <xs:union memberTypes='wst:RequestTypeEnum xs:anyURI' />
        # </xs:simpleType>
        schema = 'http://schemas.xmlsoap.org/ws/2004/04/trust'
        type = (schema,'RequestTypeOpenEnum')

        def __init__(self, pname, **kw):
            _ZSI.TC.URI.__init__(self, pname, **kw)


    # JRB NOT GENERATED BECAUSE OF UNION
    class RequestType_Dec(RequestTypeOpenEnum_Def, _ElementDeclaration):
        #  <xs:element name='RequestType' type='wst:RequestTypeOpenEnum' />
        schema = 'http://schemas.xmlsoap.org/ws/2004/04/trust'
        literal = 'RequestType'
    
        def __init__(self, **kw):
            pname = self.get_pname()
            _ns_trust.RequestTypeOpenEnum_Def.__init__(self, pname=pname, **kw)


trust_class = GetNSContainer(_SecureConversation_services_types, 'http://schemas.xmlsoap.org/ws/2004/04/trust')
#_SecureConversation_services_types.schemas_xmlsoap_org_ws_2004_04_trust.BinaryExchangeType_Def.attribute_typecode_dict = {}
trust_class.BinaryExchangeType_Def.attribute_typecode_dict = {}
trust_class.BinaryExchangeType_Def.attribute_typecode_dict = {}
trust_class.BinaryExchangeType_Def.attribute_typecode_dict['ValueType'] = _ZSI.TC.URI()
trust_class.BinaryExchangeType_Def.attribute_typecode_dict['EncodingType'] = _ZSI.TC.URI()
trust_class.BinaryExchangeType_Def.attribute_typecode_dict[("http://www.w3.org/2001/XMLSchema","anyAttribute")] = _ZSI.TC.AnyElement()
trust_class.RequestTypeOpenEnum_Def = _ns_trust.RequestTypeOpenEnum_Def
trust_class.RequestType_Dec = _ns_trust.RequestType_Dec


class _ns_address:
    targetNamespace = 'http://schemas.xmlsoap.org/ws/2004/03/addressing'

    class ReferenceParametersType_Def(_ZSI.TC.Struct, _TypeDefinition):
        #<wsa:ReferenceParameters xsi:type="wsa:ReferenceParametersType"/>
        schema = 'http://schemas.xmlsoap.org/ws/2004/03/addressing'
        type = (schema, "ReferenceParametersType")

        def __init__(self, pname, **kw):
            _ZSI.TC.Struct.__init__(self, self.__class__, [], pname=pname, inorder=0, **kw)
#_SecureConversation_services_types.schemas_xmlsoap_org_ws_2004_03_addressing.ReferenceParametersType_Def = _ns_address.ReferenceParametersType_Def
addr_class = GetNSContainer(_SecureConversation_services_types, 'http://schemas.xmlsoap.org/ws/2004/03/addressing')
addr_class.ReferenceParametersType_Def = _ns_address.ReferenceParametersType_Def





"""
# Runtime Patch for GT4. BugReport 2078 FIXED
class ContextEndpointReference_Dec( \
    SecureConversation_services_types.schemas_xmlsoap_org_ws_2004_03_addressing.EndpointReferenceType_Def,
    _ElementDeclaration):
    literal = 'ContextEndpointReference'
    schema = 'http://wsrf.globus.org/core/2004/07/security/secconv'

    def __init__(self, **kw):
        pname = self.get_pname()
        SecureConversation_services_types.schemas_xmlsoap_org_ws_2004_03_addressing.EndpointReferenceType_Def.__init__(self, pname=pname, **kw)


SecureConversation_services_types.wsrf_globus_org_core_2004_07_security_secconv.ContextEndpointReference_Dec = \
    ContextEndpointReference_Dec
"""
