import ZSI.TC


class ConsumerReference:
    '''Helper classes for specifying SOAP Data
    '''
    def __init__(self):
        self._Address = None
        self._ReferenceProperties = ReferenceProperties()

    def setAddress(self, address):
        self._Address = address

    def setReferenceProperties(self, resourceID):
        self._ReferenceProperties.setProperty(NotificationConsumerKey(resourceID))

class NotificationConsumerKey(int):
    '''Helper classes for specifying SOAP Data
    '''
    typecode = ZSI.TC.Iint(pname=("http://wsrf.globus.org/",'NotificationConsumerKey'))

class ReferenceProperties:
    '''Helper classes for specifying SOAP Data
    '''
    def __init__(self):
        self._any = None

    def setProperty(self, property):
        self._any = property


#
# Context class
#

class NotificationConsumerContext:
    '''This is not done..  Need to use a ResourceHome
    to keep track of NotificationsConsumers.
    '''
    def __init__(self, address=None):
        self.resourceID = 2000
        self.address = address

    def setAddress(self, address):
        self.address = address

    def getConsumerReference(self):
        ref = ConsumerReference()
        ref.setAddress(self.address)
        ref.setReferenceProperties(self.resourceID)
        return ref
