############################################################################
# Matt Rodriguez, LBNL
# See Copyright for copyright notice!
###########################################################################
from pyGlobus.security import GSICredential, STACK_X509_Factory


class GSIAuthentication:

    def __init__(self):
        self.__read = False
        self.__cred = GSICredential()

    def __doRead__(self):
        if self.__read:
            return
        else:
            self.__cred.read()
            self.__read = True
            
    def getPkiPath(self):
        """
        Returns the DER encoded 
        """
        self.__doRead__()
        certChain = self.__cred.get_cert_chain()
        cert = self.__cred.get_cert()
        encoding = cert.get_der_encoding()
        parentCert = certChain.pop()
        encoding += parentCert.get_der_encoding()
        return encoding

    def sign(self, signStr):
        self.__doRead__()
        pkey = self.__cred.get_key()
        signedData = pkey.sign(signStr)
        return signedData

    def verify(self, certChainInfo, hash, signature):
        stackFact = STACK_X509_Factory()
        stack = stackFact.createStackFromEncoding(certChainInfo)
        pubKey = stack.pop()
        verify = pubKey.verify(hash, signature)
        return verify
